#pragma once
#include <string>
#include "domain/physical_quantities.h"
#include "domain/program_result.h"

namespace spin
{
    class IToolController
    {
    public:
        virtual ~IToolController() = default;

        virtual void acknowledgeErrors() const = 0;
        virtual void stopMotor() const = 0;
        virtual void startMotor(const int speed_rpm, const int rampTime_ms = 500) const = 0;
        virtual void stopSafetyShield(const bool blocking = true) const = 0;
        virtual void doSafetyShieldHoming(const bool blocking = true) const = 0;
        virtual void lockBit(const bool blocking = true) const = 0;
        virtual void releaseBit(const bool blocking = true) const = 0;
        virtual void coverBit(const bool blocking = true) const = 0;
        virtual void coverScrew(const double &length, const bool blocking = true) const = 0;
        virtual void moveSafetyShieldTo(const Length &length, const bool blocking = true) const = 0;
        virtual void followRobot() const = 0;
        virtual UUID startScrewProgram(const UUID &programUuid) const = 0;
        virtual std::string programMessages() const = 0;
        virtual Speed drivingSpeedSetpoint() const = 0;
        virtual UUID latestResultUUID() const = 0;
        virtual ProgramResult::Evaluation latestResultEvaluation() const = 0;
    };
} // namespace spin